node {
    def WORKSPACE = "${JENKINS_HOME}/workspace/testtapplication"
    def dockerImageTag = "TesttApplication${env.BUILD_NUMBER}"
try{
    notifyBuild('STARTED')
    stage('Clone Repo') {
        // for display purposes
        // Get some code from a GitHub repository
        git url: 'https://gitlab.com/chaimae.bousaid/dockerjenkins.git',
            credentialsId: 'chaimae.bousaid',
            branch: 'main'
     }
    stage('Build docker') {
         dockerImage = docker.build("testtapplication:${env.BUILD_NUMBER}")
    }
    stage('Deploy docker'){
          echo "Docker Image Tag Name: ${dockerImageTag}"
          if (isUnix()) {
                          sh 'docker stop testtapplication || true && docker rm testtapplication || true'
                          sh "docker run --name testtapplication -d -p 8081:8081 testtapplication:${env.BUILD_NUMBER}"
                      } else {

                        bat "docker run --name testtapplication -d -p 8081:8081 testtapplication:${env.BUILD_NUMBER}"
                      }
}}catch(e){
    currentBuild.result = "FAILED"
    throw e
}finally{
    notifyBuild(currentBuild.result)
 }
}


def notifyBuild(String buildStatus = 'STARTED'){

  // build status of null means successful
  buildStatus =  buildStatus ?: 'SUCCESSFUL'

  // Default values
  def colorName = 'RED'
  def colorCode = '#FF0000'
  def now = new Date()

  // message
  def subject = "${buildStatus}, Job: ${env.JOB_NAME} FRONTEND - Deployment Sequence: [${env.BUILD_NUMBER}] "
  def summary = "${subject} - Check On: (${env.BUILD_URL}) - Time: ${now}"
  def subject_email = "Spring boot Deployment"
  def details = """<p>${buildStatus} JOB </p>
    <p>Job: ${env.JOB_NAME} - Deployment Sequence: [${env.BUILD_NUMBER}] - Time: ${now}</p>
    <p>Check console output at "<a href="${env.BUILD_URL}">${env.JOB_NAME}</a>"</p>"""

  }